/*

Copyright _ 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.

*/

var currentlyBeingSpoken = null;

// setup() is called when the body of the widget is loaded.  This function places the localized
// strings into the widget.


function setup()
{
	if(window.widget) {
		currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"Welcome to Voices!\" using \"Fred\"'" , doneSpeaking);
	}
}


function voiceChanged(elem)
{
	var chosenVoice = elem.options[elem.selectedIndex].value;
	document.getElementById("voiceMenuText").innerText = chosenVoice;
	
	if(window.widget) {
		if( currentlyBeingSpoken != null) {
			currentlyBeingSpoken.cancel();
			done();
		}
		currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"Hi, I`m " + chosenVoice + ".\" using \"" + chosenVoice + "\"'" , doneSpeaking);	
	}

}

function speak(event)
{
	document.getElementById("speakButton").src = "Images/Button_down.png";
	
	var textToSpeak = document.getElementById('textInput').value;
	var regExForSingleQuote = new RegExp ('\'', 'g') ;
	var textToSpeak = textToSpeak.replace(regExForSingleQuote, '`') ;
	var regExForDoubleQuote = new RegExp ('"', 'g') ;
	var textToSpeak = textToSpeak.replace(regExForDoubleQuote, '') ;

	var voiceMenu = document.getElementById('voicePopup');
	var chosenVoice = voiceMenu.options[voiceMenu.selectedIndex].value;

	var speakButtonText = document.getElementById("speakButtonText");
	speakButtonText.style.left = "97px";
	speakButtonText.innerText = "Stop";
	
	var theButton = document.getElementById("theButton");
	theButton.onmousedown = null;
	theButton.onmousedown = cancel;
	
	if(window.widget) {
		if( currentlyBeingSpoken != null) {
			currentlyBeingSpoken.cancel();
		}
		currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"" + textToSpeak + "\" using \"" + chosenVoice + "\"'" , done);	
	}
}

function cancel(event)
{
	if(window.widget) {
		currentlyBeingSpoken.cancel();
	}
	
	document.getElementById("speakButton").src = "Images/Button_down.png";

	done();
}

function done()
{
	var speakButtonText = document.getElementById("speakButtonText");
	speakButtonText.style.left = "92px";
	speakButtonText.innerText = "Speak";

	var theButton = document.getElementById("theButton");

	theButton.onmousedown = null;
	theButton.onmousedown = speak;
	
	doneSpeaking();
}

function doneSpeaking()
{
	currentlyBeingSpoken = null;
}

function buttonUpOut()
{
	document.getElementById("speakButton").src = "Images/Button.png";
}
